HDU 2639
Bone Collector II
Time Limit:2000MS Memory Limit:32768KB 64bit IO Format:%I64d & %I64u
Appoint description:
Description
The title of this problem is familiar,isn't it?yeah,if you had took part in the "Rookie Cup" competition,you must have seem this title.If you haven't seen it before,it doesn't matter,I will give you a link:
Here is the link: http://acm.hdu.edu.cn/showproblem.php?pid=2602
Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.
If the total number of different values is less than K,just ouput 0.
Here is the link: http://acm.hdu.edu.cn/showproblem.php?pid=2602
Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.
If the total number of different values is less than K,just ouput 0.
Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
Output
One integer per line representing the K-th maximum of the total value (this number will be less than 2
31).
Sample Input
3 5 10 2 1 2 3 4 5 5 4 3 2 1 5 10 12 1 2 3 4 5 5 4 3 2 1 5 10 16 1 2 3 4 5 5 4 3 2 1
Sample Output
12 2 0
这题花了我不少的时间,首先题目的意思刚开始就没能很好的理解,它是要求第K最优值
最后我一一列举才知道,它的意思,就是这个背包所有可能装下的价值的中的第K个
比如第一个样例,那个背包能装下14 12 11 10 9 8 7 6 5 4 3 2 1第二个就是12咯
1,知道题意之后,发现这题还是挺不容易的,因为本来01背包只维护最优的那一个就可以了
现在我要维护第K大个,怎么存,那么只能每一个情况都存K个数字咯
2,数组就要开成dp[1005][35]每一种情况都要存前最优的k个
3,然后就是区间合并,这个不好理解,我也参考了很多资料,多花时间想一想或许就明白了
#include<bits/stdc++.h>
using namespace std;
const int maxn = 105 ;
int n,v,k ;
int volume[maxn] ;
int value[maxn] ;
int dp[1005][35];
int A[35] ;
int B[35] ;
int main(){
int T ;
scanf("%d",&T);
while(T--){
scanf("%d%d%d",&n,&v,&k);
for(int i=1;i<=n;i++)scanf("%d",&value[i]);
for(int i=1;i<=n;i++)scanf("%d",&volume[i]);
memset(dp,0,sizeof(dp)) ;
for(int i=1;i<=n;i++){
for(int j = v;j>=volume[i];j--){
for(int kk=1;kk<=k;kk++){
A[kk] = dp[j-volume[i]][kk]+value[i] ;
B[kk] = dp[j][kk] ;
}
A[k+1] = B[k+1] = -1 ;
int a=1,b=1,c=1 ;
while(c<=k&&(A[a]!=-1||B[b]!=-1)){
if(A[a]>B[b])dp[j][c]=A[a++] ;
else dp[j][c]=B[b++] ;
if(dp[j][c]!=dp[j][c-1])c++ ;
}
}
}
printf("%d\n",dp[v][k]);
}
return 0;
}